﻿using System;
using System.Text;
using System.ComponentModel;

namespace SilverlightConsole {
  public static class SLConsole {
    static SLConsole() {
    }

    public static IBindableString Output {
      get { return _output; }
    }

    public static void WriteLine(String output = "") {
      Write(output + "\n");
    }

    private static void Write(String output) {
      __buffer.Append(output);
      _output.StringValue = __buffer.ToString();
    }

    private static StringBuilder __buffer = new StringBuilder();
    private static BindableString _output = new BindableString();
  }

  public interface IBindableString : INotifyPropertyChanged {
    String StringValue { get; }
  }

  public class BindableString : IBindableString {
    public BindableString() {
    }

    public String StringValue {
      get {
        return _value;
      }
      set {
        _value = value;
        RaisePropertyChanged("StringValue");
      }
    }

    public event PropertyChangedEventHandler PropertyChanged = delegate { };

    protected void RaisePropertyChanged(String propertyName) {
      PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
    }

    private static String _value = "";
  }
}
