﻿Imports System.Text
Imports System.ComponentModel

Namespace SilverlightConsole
  Public NotInheritable Class SLConsole
	Private Sub New()
	End Sub
	Shared Sub New()
	End Sub

	Public Shared ReadOnly Property Output() As IBindableString
	  Get
		  Return _output
	  End Get
	End Property

	Public Shared Sub WriteLine(Optional ByVal output As String = "")
	  Write(output & vbLf)
	End Sub

	Private Shared Sub Write(ByVal output As String)
	  __buffer.Append(output)
	  _output.StringValue = __buffer.ToString()
	End Sub

	Private Shared __buffer As New StringBuilder()
	Private Shared _output As New BindableString()
  End Class

  Public Interface IBindableString
	  Inherits INotifyPropertyChanged
    Property StringValue() As String
  End Interface

  Public Class BindableString
	  Implements IBindableString
	Public Sub New()
	End Sub

	Public Property StringValue() As String Implements IBindableString.StringValue
	  Get
		Return _value
	  End Get
	  Set(ByVal value As String)
		_value = value
		RaisePropertyChanged("StringValue")
	  End Set
	End Property

	Public Event PropertyChanged As PropertyChangedEventHandler Implements System.ComponentModel.INotifyPropertyChanged.PropertyChanged

	Protected Sub RaisePropertyChanged(ByVal propertyName As String)
	  RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyName))
	End Sub

	Private Shared _value As String = ""
  End Class
End Namespace
